namespace CCI.CrestronHomeBridge.SimplLibrary;
        // class declarations
         class CommandProcessor;
         class AComponent;
         class AComponentDisableHide;
         class AComponentHide;
         class ButtonComponent;
         class ButtonGroupComponent;
         class CheckboxComponent;
         class ControlGroupComponent;
         class DirectionalKeypadComponent;
         class KeypadComponent;
         class RadialGaugeSignedComponent;
         class RadialGaugeComponent;
         class RaiseLowerWithTextSignedComponent;
         class RaiseLowerWithTextComponent;
         class SubheaderComponent;
         class TextEntryComponent;
         class ToggleComponent;
         class ToggleSliderSignedComponent;
         class TextDisplayComponent;
         class ToggleSliderComponent;
         class DigitalEventArgs;
         class SerialEventArgs;
         class AnalogEventArgs;
         class SignedAnalogEventArgs;
         class ColorPaletteMap;
         class Registrar;
         class IntersystemServer;
         class ComponentComparer;
         class NumericComparer;
         class StringLogicalComparer;
     class CommandProcessor 
    {
        // class delegates

        // class events
        EventHandler OnDebugChange ( CommandProcessor sender, SerialEventArgs args );
        EventHandler OnCommunicatingChange ( CommandProcessor sender, AnalogEventArgs args );
        EventHandler OnInitializedChange ( CommandProcessor sender, AnalogEventArgs args );
        EventHandler OnDebugEnabledChange ( CommandProcessor sender, AnalogEventArgs args );
        EventHandler OnComponentCountChange ( CommandProcessor sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( INTEGER commandProcessorID , INTEGER ipPort , STRING layoutID , STRING title , STRING subtitle , STRING icon , STRING secondaryIcon , STRING alternateIcon , INTEGER displayOnPage , INTEGER performFunction , STRING actionName , STRING status );
        FUNCTION StartServer ();
        FUNCTION StopServer ();
        FUNCTION RestartServer ();
        FUNCTION EnableDebug ( INTEGER state );
        FUNCTION SetTitle ( STRING value );
        FUNCTION SetSubtitle ( STRING value );
        FUNCTION SetIcon ( STRING value );
        FUNCTION SetSecondaryIcon ( STRING value );
        FUNCTION SetAlternateIconText ( STRING value );
        FUNCTION SetStatus ( STRING value );
        FUNCTION RegistrationFinished ();
        FUNCTION Debug ( STRING msg );
        FUNCTION Dispose ();
        STRING_FUNCTION ToString ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();

        // class variables
        INTEGER __class_id__;

        // class properties
        INTEGER id;
    };

     class AComponentDisableHide 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION SetDisable ( INTEGER state );
        FUNCTION SetHide ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class AComponentHide 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION SetHide ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class ButtonComponent 
    {
        // class delegates

        // class events
        EventHandler OnPressChange ( ButtonComponent sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING icon , INTEGER navigationType , STRING navigationName , INTEGER hidden , INTEGER disabled );
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetIcon ( STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class ButtonGroupComponent 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , INTEGER hidden );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class CheckboxComponent 
    {
        // class delegates

        // class events
        EventHandler OnStateChange ( CheckboxComponent sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING secondaryLabel , INTEGER hidden , INTEGER disabled );
        FUNCTION SetState ( INTEGER value );
        FUNCTION ToggleState ();
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetSecondaryLabel ( STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class ControlGroupComponent 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , INTEGER hidden );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class DirectionalKeypadComponent 
    {
        // class delegates

        // class events
        EventHandler OnPressChange ( DirectionalKeypadComponent sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , INTEGER hidden , INTEGER disabled );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class KeypadComponent 
    {
        // class delegates

        // class events
        EventHandler OnPressChange ( KeypadComponent sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , INTEGER function1Enabled , STRING function1Label , INTEGER function2Enabled , STRING function2Label , INTEGER hidden , INTEGER disabled );
        FUNCTION SetFunctionButtonLabel ( INTEGER index , STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class RadialGaugeSignedComponent 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING line1Label , STRING line2Label , STRING line3Label , SIGNED_INTEGER minValue , SIGNED_INTEGER maxValue , INTEGER stepSize , INTEGER useValueForLabel , INTEGER color , INTEGER hidden , INTEGER disabled );
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetLineLabel ( INTEGER index , STRING value );
        FUNCTION SetValue ( SIGNED_INTEGER value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class RadialGaugeComponent 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING line1Label , STRING line2Label , STRING line3Label , INTEGER minValue , INTEGER maxValue , INTEGER stepSize , INTEGER useValueForLabel , INTEGER color , INTEGER hidden , INTEGER disabled );
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetLineLabel ( INTEGER index , STRING value );
        FUNCTION SetValue ( INTEGER value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class RaiseLowerWithTextSignedComponent 
    {
        // class delegates

        // class events
        EventHandler OnValueChange ( RaiseLowerWithTextSignedComponent sender, SignedAnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING valueFormat , SIGNED_INTEGER minValue , SIGNED_INTEGER maxValue , INTEGER stepSize , INTEGER hidden , INTEGER disabled );
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetValue ( SIGNED_INTEGER value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class RaiseLowerWithTextComponent 
    {
        // class delegates

        // class events
        EventHandler OnValueChange ( RaiseLowerWithTextComponent sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING valueFormat , INTEGER minValue , INTEGER maxValue , INTEGER stepSize , INTEGER hidden , INTEGER disabled );
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetValue ( INTEGER value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class SubheaderComponent 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , INTEGER hidden );
        FUNCTION SetLabel ( STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class TextEntryComponent 
    {
        // class delegates

        // class events
        EventHandler OnValueChange ( TextEntryComponent sender, SerialEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING errorText , INTEGER obscureInput , INTEGER numericInputOnly , INTEGER hidden , INTEGER disabled );
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetErrorText ( STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class ToggleComponent 
    {
        // class delegates

        // class events
        EventHandler OnStateChange ( ToggleComponent sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING secondaryLabel , INTEGER navigationType , STRING navigationName , INTEGER hidden , INTEGER disabled );
        FUNCTION SetState ( INTEGER value );
        FUNCTION ToggleState ();
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetSecondaryLabel ( STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class ToggleSliderSignedComponent 
    {
        // class delegates

        // class events
        EventHandler OnToggleChange ( ToggleSliderSignedComponent sender, AnalogEventArgs args );
        EventHandler OnSliderChange ( ToggleSliderSignedComponent sender, SignedAnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING secondaryLabel , SIGNED_INTEGER minValue , SIGNED_INTEGER maxValue , INTEGER stepSize , INTEGER hidden , INTEGER disabled );
        FUNCTION ToggleToggle ();
        FUNCTION SetToggle ( INTEGER state );
        FUNCTION SetSlider ( SIGNED_INTEGER value );
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetSecondaryLabel ( STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class TextDisplayComponent 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING title , STRING line1Label , STRING line2Label , STRING line3Label , INTEGER hidden , INTEGER disabled );
        FUNCTION SetTitle ( STRING value );
        FUNCTION SetLineLabel ( INTEGER index , STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class ToggleSliderComponent 
    {
        // class delegates

        // class events
        EventHandler OnToggleChange ( ToggleSliderComponent sender, AnalogEventArgs args );
        EventHandler OnSliderChange ( ToggleSliderComponent sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING symbolInstanceName , INTEGER commandProcessorID , STRING componentID , INTEGER parentType , STRING parentID , STRING label , STRING secondaryLabel , INTEGER minValue , INTEGER maxValue , INTEGER stepSize , INTEGER hidden , INTEGER disabled );
        FUNCTION ToggleToggle ();
        FUNCTION SetToggle ( INTEGER state );
        FUNCTION SetSlider ( INTEGER value );
        FUNCTION SetLabel ( STRING value );
        FUNCTION SetSecondaryLabel ( STRING value );
        FUNCTION ProcessResponse ( STRING response );
        FUNCTION Dispose ();
        FUNCTION SetHide ( INTEGER state );
        FUNCTION SetDisable ( INTEGER state );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class DigitalEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class SerialEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING payload[];
    };

     class AnalogEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        INTEGER payload;
    };

     class SignedAnalogEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_INTEGER payload;
    };

     class ColorPaletteMap 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap DEFAULT;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap RED;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap ORANGE;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap YELLOW;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap GREEN;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap LIGHT_BLUE;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap BLUE;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap PURPLE;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap PINK;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap MID_GRAY;
        static CCI.CrestronHomeBridge.SimplLibrary.ColorPaletteMap DARK_GRAY;

        // class properties
        SIGNED_LONG_INTEGER index;
        STRING value[];
    };

    static class Registrar 
    {
        // class delegates

        // class events

        // class functions
        static INTEGER_FUNCTION GetNextComponentId ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class ComponentComparer 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class NumericComparer 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class StringLogicalComparer 
    {
        // class delegates

        // class events

        // class functions
        static SIGNED_LONG_INTEGER_FUNCTION Compare ( STRING s1 , STRING s2 );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

